(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../injector", "./services/chat", "./services/crud", "./services/file", "./services/log", "./services/proxy", "./services/upload"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const injector_1 = require("../injector");
    const chat_1 = require("./services/chat");
    const crud_1 = require("./services/crud");
    const file_1 = require("./services/file");
    const log_1 = require("./services/log");
    const proxy_1 = require("./services/proxy");
    const upload_1 = require("./services/upload");
    function getServiceInjector() {
        return injector_1.createInjector('service', [
            ['chat', chat_1.chatServiceFactory],
            ['crud', crud_1.crudServiceFactory],
            ['file', file_1.fileServiceFactory],
            ['log', log_1.logServiceFactory],
            ['proxy', proxy_1.proxyServiceFactory],
            ['upload', upload_1.uploadServiceFactory]
        ]);
    }
    exports.getServiceInjector = getServiceInjector;
});
//# sourceMappingURL=loader.js.map