(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../core/middleware/response", "../../../core/processors/before/body.processor", "../../../core/processors/log.processor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const response_1 = require("../../../core/middleware/response");
    const body_processor_1 = require("../../../core/processors/before/body.processor");
    const log_processor_1 = require("../../../core/processors/log.processor");
    exports.logServiceFactory = (config) => {
        const { respondOk } = config;
        return {
            global: {
                before: [body_processor_1.body({}), log_processor_1.logRequest({ logBody: true })]
            },
            route: respondOk
                ? {
                    middleware: response_1.response({ statusCode: 200 })
                    // eslint-disable-next-line no-mixed-spaces-and-tabs
                }
                : undefined
        };
    };
});
//# sourceMappingURL=log.js.map