import { ServerControls } from '../core/servers/startServer';
import { Config } from './utils/config';
import { Environment } from './utils/environment';
/**
 * Starts a server from a config.
 *
 * Lifecycle for start:
 *
 * 1. load the configuration
 * 2. set the log level
 * 3. load externals
 * 4. boot services
 * 5. start the server
 *
 * @param config a Config or a path that can be used to load a config
 * @param app an App to manage the server
 */
export default function start(config: Config | string, envConfig?: Partial<Environment>): Promise<ServerControls[]>;
