export declare function getInjector<T>(type: string): Injector<Factory<T>> | undefined;
export declare function hasInjector(type: string): boolean;
export declare function createInjector<T>(type: string, initial?: [string, Factory<T, any>][]): Injector<T>;
export declare type Factory<T, CONFIG extends object = object> = (config: CONFIG) => T;
export declare class Injector<T> {
    private id;
    private factoryMap;
    constructor(id: string, initial?: [string, Factory<T>][]);
    get<C extends object = object>(name: string): Factory<T, C>;
    register(name: string, factory: Factory<T>): void;
}
