import { TypeScriptConfig } from './addons';
import { ExternalMap } from './externals';
import { Server } from './server';
export interface Config {
    externals?: ExternalMap;
    logLevel?: string;
    servers: Server[];
    tsConfig?: TypeScriptConfig;
}
export interface LoadedConfig {
    config: Config;
    configPath: string;
}
/**
 * @returns a config at the provided path, the default config, or undefined if none exist
 */
export declare function loadConfig(path?: string): LoadedConfig | Promise<LoadedConfig>;
