(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "uuid"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const uuid_1 = require("uuid");
    exports.$Env = Symbol('Environment ' + uuid_1.v4());
    function isEnvironment(value) {
        return (typeof value === 'object' &&
            typeof value.configPath === 'string' &&
            (!value.properties || typeof value.properties === 'object'));
    }
    exports.isEnvironment = isEnvironment;
    function createEnvironment() {
        return {
            configPath: process.cwd()
        };
    }
    exports.createEnvironment = createEnvironment;
});
//# sourceMappingURL=environment.js.map