(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "../factories/loader"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const path_1 = require("path");
    const loader_1 = require("../factories/loader");
    function isServiceFactory(value) {
        return value && typeof value === 'function';
    }
    function loadExternals(externals = {}, env) {
        for (let [name, config] of Object.entries(externals)) {
            const path = path_1.resolve(path_1.join(env.configPath, config.path));
            const loader = require(path);
            const injector = loader_1.getServiceInjector();
            if (typeof loader === 'object') {
                if (isServiceFactory(loader.default)) {
                    injector.register(name, loader.default);
                }
                else if (isServiceFactory(loader)) {
                    injector.register(name, loader);
                }
                else if (isServiceFactory(loader.loader)) {
                    injector.register(name, loader.loader);
                }
                else {
                    throw new Error(`"${path}" is not a service loader`);
                }
            }
            else {
                throw new Error(`"${path}" is not a service loader`);
            }
        }
    }
    exports.loadExternals = loadExternals;
});
//# sourceMappingURL=externals.js.map