/// <reference types="node" />
import { ServerOptions } from 'https';
import { App } from '../../core/app';
import { Environment } from './environment';
export interface Server {
    httpsOptions?: ServerOptions;
    name?: string;
    port?: number;
    services: ServiceConfig[];
    type?: 'http' | 'https';
}
export interface ServiceConfig {
    name: string;
    [key: string]: any;
}
export declare function startServer(app: App, { type, port, httpsOptions }?: Omit<Server, 'services'>): Promise<import("../../core/servers/startServer").ServerControls>;
export declare function bootServer(server: Server, env: Environment, app?: App): Promise<import("../../core/servers/startServer").ServerControls>;
