(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.headerGuard = (headers) => {
        const list = Object.entries(headers);
        return (request) => {
            for (let [name, value] of list) {
                if (request.headers[name] !== value) {
                    return false;
                }
            }
            return true;
        };
    };
});
//# sourceMappingURL=headers.js.map