(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.some = ({ guards }) => {
        return (request) => {
            for (const guard of guards) {
                if (guard(request)) {
                    return true;
                }
            }
            return false;
        };
    };
    exports.every = ({ guards }) => {
        return (request) => {
            for (const guard of guards) {
                if (!guard(request)) {
                    return false;
                }
            }
            return true;
        };
    };
});
//# sourceMappingURL=logic.js.map