(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./logic", "./path"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const logic_1 = require("./logic");
    const path_1 = require("./path");
    exports.methodGuard = ({ method }) => {
        return (request) => {
            return request.method.toLowerCase() === method;
        };
    };
    const routeGuard = (method) => {
        return (route) => {
            if (route) {
                return logic_1.every({ guards: [exports.methodGuard({ method }), path_1.pathGuard({ match: route })] });
            }
            return exports.methodGuard({ method });
        };
    };
    exports.method = {
        get: routeGuard('get'),
        post: routeGuard('post'),
        put: routeGuard('put'),
        delete: routeGuard('delete')
    };
});
//# sourceMappingURL=method.js.map