(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "winston"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const winston_1 = require("winston");
    /**
     * Global logger instance used with Winston
     */
    exports.log = new winston_1.Logger({
        transports: [new winston_1.transports.Console()]
    });
    /**
     * Change the global logger instance
     */
    function setLogger(logger) {
        exports.log = logger;
    }
    exports.setLogger = setLogger;
    /**
     * Sets the log level for all transports
     * @param level the log level
     */
    function setLogLevel(level) {
        for (let key in exports.log.transports) {
            const transport = exports.log.transports[key];
            transport.level = level;
        }
    }
    exports.setLogLevel = setLogLevel;
});
//# sourceMappingURL=log.js.map