(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../log", "./response"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const log_1 = require("../log");
    const response_1 = require("./response");
    exports.forwarder = ({ location }) => {
        const responseHandler = response_1.response({
            header: { Location: location },
            statusCode: 301
        });
        return (request, response) => {
            log_1.log.debug(`Forwarding ${request.url} to ${location}`);
            responseHandler(request, response);
        };
    };
});
//# sourceMappingURL=forwarder.js.map