(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../log", "./response"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const log_1 = require("../log");
    const response_1 = require("./response");
    exports.notFound = () => {
        const responseHandler = response_1.response({
            message: 'Not Found',
            statusCode: 404
        });
        return (request, response) => {
            log_1.log.debug(`Not Found: ${request.url}`);
            responseHandler(request, response);
        };
    };
});
//# sourceMappingURL=notFound.js.map