var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "../HttpError", "../log", "../util/file/getStat", "../util/file/sendFile"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const path_1 = require("path");
    const HttpError_1 = require("../HttpError");
    const log_1 = require("../log");
    const getStat_1 = require("../util/file/getStat");
    const sendFile_1 = require("../util/file/sendFile");
    exports.serveFile = ({ path }) => {
        const base = path_1.resolve(path);
        log_1.log.debug('serving file', base);
        return (request, response) => __awaiter(void 0, void 0, void 0, function* () {
            const stat = yield getStat_1.getStat(path);
            if (stat.isFile()) {
                yield sendFile_1.sendFile(request, response, path);
            }
            else {
                log_1.log.error(`serveFile middleware expected file "${path} to exist`);
                throw new HttpError_1.HttpError(404 /* NotFound */);
            }
        });
    };
});
//# sourceMappingURL=serveFile.js.map