(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "http", "./startServer"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const http_1 = require("http");
    const startServer_1 = require("./startServer");
    function createHttpServer(config) {
        return () => {
            const server = http_1.createServer(config.onRequest);
            config.timeout && server.setTimeout(config.timeout);
            return Promise.resolve(server);
        };
    }
    exports.createHttpServer = createHttpServer;
    function startHttpServer(config) {
        return startServer_1.startServer(Object.assign(Object.assign({}, config), { createServer: createHttpServer(config) }));
    }
    exports.startHttpServer = startHttpServer;
});
//# sourceMappingURL=createHttpServer.js.map