(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../upgrades/realtime.upgrade"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const realtime_upgrade_1 = require("../upgrades/realtime.upgrade");
    exports.echoMessage = (data, con, { getAll }) => {
        const socketId = con.id;
        for (let target of getAll()) {
            if (target.id !== socketId) {
                target.client.send(data);
            }
        }
    };
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function chatService(props) {
        var _a;
        return {
            upgrade: {
                guards: (_a = props.guards, (_a !== null && _a !== void 0 ? _a : [])),
                upgrade: realtime_upgrade_1.realtimeUpgrade(Object.assign({ onMessage: exports.echoMessage }, props))
            }
        };
    }
    exports.chatService = chatService;
});
//# sourceMappingURL=chat.service.js.map