(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../guards/method", "../middleware/serve", "../processors/cache.processor", "../transforms/directory.transform", "../transforms/json.transform"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const method_1 = require("../guards/method");
    const serve_1 = require("../middleware/serve");
    const cache_processor_1 = require("../processors/cache.processor");
    const directory_transform_1 = require("../transforms/directory.transform");
    const json_transform_1 = require("../transforms/json.transform");
    function fileService(props) {
        const { route = '*' } = props;
        return {
            route: {
                before: [cache_processor_1.noCache],
                guards: [method_1.method.get(route)],
                middleware: serve_1.serve(props),
                transforms: [directory_transform_1.directoryTransform, json_transform_1.jsonTransform]
            }
        };
    }
    exports.fileService = fileService;
});
//# sourceMappingURL=file.service.js.map