(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../middleware/proxy", "../upgrades/proxy.upgrade", "../util/createProxy"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const proxy_1 = require("../middleware/proxy");
    const proxy_upgrade_1 = require("../upgrades/proxy.upgrade");
    const createProxy_1 = require("../util/createProxy");
    function proxyService(props) {
        const route = props.route || '/';
        const proxy = createProxy_1.createProxy(props);
        return {
            route: {
                middleware: proxy_1.proxy({ baseUrl: route, proxy })
            },
            upgrade: {
                upgrade: proxy_upgrade_1.proxyUpgrade({ baseUrl: route, proxy })
            }
        };
    }
    exports.proxyService = proxyService;
});
//# sourceMappingURL=proxy.service.js.map