(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../log"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const log_1 = require("../log");
    /**
     * This connects a local websocket to a proxied websocket
     */
    exports.proxyUpgrade = ({ baseUrl, proxy }) => {
        return (request, socket, head) => {
            log_1.log.debug(`Upgrade request for proxied "${baseUrl}"`);
            socket.on('close', () => {
                log_1.log.debug('Socket closed');
            });
            socket.on('connect', () => {
                log_1.log.debug('Socket connect');
            });
            proxy.ws(request, socket, head);
        };
    };
});
//# sourceMappingURL=proxy.upgrade.js.map