/// <reference types="node" />
import { IncomingMessage } from 'http';
import WebSocket from 'ws';
import { UpgradeListenerFactory } from '../interface';
export interface WebSocketProperties {
    onConnection?(client: WebSocket, socketId: string, request: IncomingMessage): void;
    onMessage?(socketId: string, message: any): void;
    onClose?(socketId: string, code: number, reason: string): void;
    onError?(socketId: string, error: Error): void;
}
/**
 * This provides a very basic implementation of the WebSocket upgrade process needed
 * to establish a WebSocket connection.
 */
export declare const websocket: UpgradeListenerFactory<WebSocketProperties>;
