var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "uuid", "ws"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const uuid_1 = require("uuid");
    const ws_1 = require("ws");
    /**
     * This provides a very basic implementation of the WebSocket upgrade process needed
     * to establish a WebSocket connection.
     */
    exports.websocket = ({ onClose, onConnection, onError, onMessage }) => {
        const ws = new ws_1.Server({ noServer: true });
        const upgrader = (request, socket, head) => __awaiter(void 0, void 0, void 0, function* () {
            yield new Promise((resolve) => {
                const socketId = uuid_1.v4();
                ws.handleUpgrade(request, socket, head, (client) => {
                    var _a;
                    (_a = onConnection) === null || _a === void 0 ? void 0 : _a(client, socketId, request);
                    onMessage && client.on('message', (data) => onMessage(socketId, data));
                    onClose && client.on('close', (code, reason) => onClose(socketId, code, reason));
                    onError && client.on('error', (err) => onError(socketId, err));
                    resolve();
                });
            });
        });
        Object.defineProperties(upgrader, {
            ws: {
                value: ws,
                writable: false
            }
        });
        return upgrader;
    };
});
//# sourceMappingURL=websocket.upgrade.js.map