(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const fs_1 = require("fs");
    function getStat(target) {
        return new Promise((resolve, reject) => {
            fs_1.stat(target, (err, stats) => {
                err ? reject(err) : resolve(stats);
            });
        });
    }
    exports.getStat = getStat;
});
//# sourceMappingURL=getStat.js.map