var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "send", "../../../core/log"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const send_1 = __importDefault(require("send"));
    const log_1 = require("../../../core/log");
    function sendFile(request, response, target) {
        return new Promise((resolve, reject) => {
            log_1.log.debug(`ServePath: serving file "${target}"`);
            send_1.default(request, target, {
                dotfiles: 'deny',
                index: false
            })
                .on('end', function () {
                response.end();
                resolve();
            })
                .on('error', reject)
                .pipe(response);
        });
    }
    exports.sendFile = sendFile;
});
//# sourceMappingURL=sendFile.js.map