(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function updateRequest(request, params) {
        for (let [key, value] of Object.entries(params)) {
            request[key] = value;
        }
    }
    exports.updateRequest = updateRequest;
    function getParams(request, ...keys) {
        const params = {};
        for (let key of keys) {
            params[key] = request[key];
        }
        return params;
    }
    exports.getParams = getParams;
});
//# sourceMappingURL=request.js.map